#include <bits/stdc++.h>

using namespace std;

unordered_map<long long,long long> memo;

long long func(long long n)
{
    long long a=1;
    while(n>0 && a!=0)
    {
        a*=n%10;
        n/=10;
    }
    return a;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);


    int T;
    if(!(cin>>T))
        return 0;

    vector<long long> res;
    while(T--)
    {
        long long n;
        cin >> n;
        unordered_set<long long> a;
        for(long long i=1; i<=n; i++)
        {
            if(memo.count(i))a.insert(memo[i]);
            else
            {
                long long x=func(i);
                memo.insert(make_pair(i,x));
                a.insert(x);
            }
        }
        res.push_back(a.size());
    }
    for(auto i:res)cout << i << endl;

    return 0;
}